Skip to main content

Recursion - Medium Level - Question 2

Recursion - Medium Level - Question 2


Leetcode 1922 Count Good Numbers

A digit string is good if the digits (0-indexed) at even indices are even and the digits at odd indices are prime (2, 3, 5, or 7).


For example, "2582" is good because the digits (2 and 8) at even positions are even and the digits (5 and 2) at odd positions are prime. However, "3245" is not good because 3 is at an even index but is not even.

Given an integer n, return the total number of good digit strings of length n. Since the answer may be large, return it modulo 10^9 + 7.


A digit string is a string consisting of digits 0 through 9 that may contain leading zeros.


Constraints:

1 <= n <= 10^15


Analysis:

One of the keys is how to keep the question still the "same question".

It is clear that for this question, the total number is "5 * 4 * 5 * 4 * 5 * 4 ...", which are apparently repetitive operations. So we do not need to calculate it one by one, which is NOT the most efficient method.

We can divide it into two parts: depending on its length, 

 if the first part is even, then the second part can always start with 5, or the same as the original question;

if the first part is odd, then the second part will start with 4, which is NOT the same as the original question. But we make it to the same: since we know it will start with 4, we can re-write it as 4 * (the remaining part), where the remaining part starts with 5 again.

Another key is to just calculate one for each length.


See the code below:


class Solution {
public:
    int countGoodNumbers(long long n) {
        int mod = 1e9 + 7;
        if(n==0) return 1;
        if(n==1) return 5;
        if(n==2) return 20;
        long d = n/2, t = 1;
        if(n&1) {
            t = countGoodNumbers(d);
            // n = 3, 7, ...
            if(d&1) return t*4*t%mod;
            // n = 5, 9, ...
            return t*5*t%mod;
        }
        if(d&1) {
            // n = 6, 10, ...
            t = countGoodNumbers(d-1);
            return t*5%mod*4*t%mod;
        }
        // n = 4, 8, ...
        t = countGoodNumbers(d);
        return t*t%mod;
    }
};

A different way to divide the n:


We can always to take the power of 2 as the first part, then it will always to be even (even after division by half). 

See the code below:


class Solution {
public:
    int countGoodNumbers(long long n) {
        if(n==0) return 1;
        if(n==1) return 5;
        if(n==2) return 20;
        // this line (or base case) is needed
        if(n==3) return 100;
        long mod = 1e9 + 7, s = pow(2, floor(log2(n)));
        long t = countGoodNumbers(s/2)%mod;
        long r = countGoodNumbers(n - s)%mod;
        return (t*t%mod)*r%mod;
    }
};

Please be noted that the above code may re-calculate some intermediate states, but it is till fast enough to coverge.



Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...